質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.12%

[Python]venv環境でpipを--upgradeするとエラー

解決済

回答 2

投稿

  • 評価
  • クリップ 0
  • VIEW 586

CyTami

score 0

[Python]venv環境でpipを--upgradeしたい

プロジェクトディレクトリ直下にvenvによる環境をつくりました。
activateし、pipのバージョンを更新しようとしたところ以下のようなエラーが出てしまい困っています。

エラー内容も--userオプションもどういったものかよくわからない状況です。

(venv) PS "プロジェクトディレクトリ"> pip install --upgrade pip
Collecting pip
Using cached
https://files.pythonhosted.org/packages/30/db/9e38760b32e3e7f40cce46dd5fb107b8c73840df38f0046d8e6514e675a1/pip-19.2.3-py2.py3-none-any.whl
Installing collected packages: pip
  Found existing installation: pip 19.0.3
      Uninstalling pip-19.0.3:
Could not install packages due to an EnvironmentError: [WinError 5] アクセスが拒否されました。: 'd:\\"プロジェクトディレクトリ"\\venv\\scripts\\pip.exe'
Consider using the `--user` option or check the permissions.

原因や解決策のわかるかたがいましたらお教えください。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

check解決した方法

0

jeanbiegoさんの方法をもとにいくつかの方法を試みましたがだめでした。
しかし、その後あっけなく解決したので記します。

原因

憶測ですがUninstalling pip-19.0.3:と出ているので、おそらくpipをアンインストールしたために、

Could not install packages due to an EnvironmentError: [WinError 5] アクセスが拒否されました。: 'd:\\"プロジェクトディレクトリ"\\venv\\scripts\\pip.exe'


というように存在しないpipを利用しようとしてエラーとなったのでしょう。

解決方法

いくつかの方法を試みる中でvenv環境にactivateした状態でもpythonコマンドはシステムのユーザーディレクトリのものを参照していることに気が付きました。

その上で、pipのバージョンが古い場合に表示されるメッセージ

You are using pip version 19.0.3, however version 19.2.3 is available.
You should consider upgrading via the 'python -m pip install --upgrade pip' command.

メッセージに従ってコマンドを入力した。
pip install -U pipではなく、python -m pip install -U pipです。
python -mを付記することで、ユーザーディレクトリのpipを使ってvenvディレクトリのpipをアンインストール、最新版pipのインストールを行うためにエラーとはならないようです。

結論

python -m pip install -U pip


でvenvのpipを更新できます。
普段はpython -mはなくても正常に動きますが、venvではpython -mつけないと失敗します

面倒だからと省略しなければよかった...

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

0

ぐぐったら下記の記事がありました。原因2が近いようですので、記載の方法を試されてはいかがでしょうか。
pip installでエラーになりインストールできない場合

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.12%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる